# SourcePath: openssl/20160802dev
%define libmaj 1
%define libmin 0
%define librel 2
%define librev h
Release: 08020201

%define openssldir %{sony_target_dev_lib_dir}/ssl
%define sony_target_arch debian-%{sony_target_cpu_longname}
%define shlib_maj 1
%define shlib_min 0.0
# sony_target_cpu_longname is "powerpc" or "arm"
%define sony_target_arch debian-armel
Summary: Secure Sockets Layer and cryptography libraries and tools
Name: sony-target-dev-openssl
%define pkgname %{sony_tool_triplet}-%{sony_target_dialect}-dev-openssl
Version: %{libmaj}.%{libmin}.%{librel}%{librev}
Source0: openssl-%{version}.tar.gz
Source1: openssl_1.0.2g-1ubuntu1.debian.tar.gz
Patch1: openssl_%{version}-configure.patch

License: OpenSSL license / SSLeay license
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
Provides: SSL
URL: http://www.openssl.org/
BuildRoot:   /var/tmp/%{name}-%{version}-root
Prefix: %{sony_target_dir}
%define _docdir         %{sony_target_dir}%{sony_target_dev_doc_dir}


%description
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, fully featured, and Open Source toolkit implementing the
Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1)
protocols as well as a full-strength general purpose cryptography library.
The project is managed by a worldwide community of volunteers that use the
Internet to communicate, plan, and develop the OpenSSL tookit and its related
documentation. 

%package -n %{pkgname}
Summary: Secure Sockets Layer and cryptography static libraries and headers
Group: %{sony_group}
AutoReqProv: no

%description -n %{pkgname}
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, fully featured, and Open Source toolkit implementing the
Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1)
protocols as well as a full-strength general purpose cryptography library.
The project is managed by a worldwide community of volunteers that use the
Internet to communicate, plan, and develop the OpenSSL tookit and its related
documentation. 


%prep
# %target_check
%setup -q -n openssl-%{version} -q -a 1
%patch1 -p1

cd ${RPM_BUILD_DIR}/openssl-%{version}
patch -p1 < debian/patches/debian-targets.patch
sed 's/openssl-1.0.0\/engines/ssl\/engines/g' debian/patches/engines-path.patch > debian/patches/engines-path.patch.tmp
mv debian/patches/engines-path.patch.tmp debian/patches/engines-path.patch
patch -p1 < debian/patches/engines-path.patch
patch -p1 < debian/patches/no-rpath.patch
patch -p1 < debian/patches/no-symbolic.patch
patch -p1 < debian/patches/pic.patch
patch -p1 < debian/patches/shared-lib-ext.patch
patch -p1 < debian/patches/version-script.patch
%build 
%sony_target_dev_setup
# acck, gaaagh, choke  horrible hack
perl -spi -e "s/\"gcc:/\"%{sony_target_toolprefix}gcc %{sony_target_machine_option}:/" Configure
perl -spi -e "s/which\(\"ranlib\"\)/which\(\"%{sony_target_toolprefix}ranlib\"\)/" Configure

perl util/perlpath.pl /usr/bin/perl

# Define the global setups..
%define CONFIG_FLAGS --prefix=%{sony_target_dev_prefix} no-idea no-mdc2 no-rc5 no-ec --openssldir=%{openssldir}

# First we build static libs...
./Configure no-shared %{CONFIG_FLAGS} %{sony_target_arch}
make depend
make -f Makefile DIRS="crypto ssl" all
mv libcrypto.a libcrypto.static
mv libssl.a libssl.static
make -f Makefile DIRS="crypto ssl" clean

# Next we build shared libs...
./Configure shared %{CONFIG_FLAGS} %{sony_target_arch}
ln -sf apps/openssl.pod crypto/crypto.pod ssl/ssl.pod doc/

# Multi-dialect support modification in Makefile
mv Makefile Makefile.orig
sed -e "s/FIPSLD_CC=\$(CC)/FIPSLD_CC='\$(CC)'/g" -e 's/CC=$${CC}/CC="$${CC}"/g' Makefile.orig > Makefile
mv apps/Makefile apps/Makefile.orig
sed -e "s/FIPSLD_CC=\$(CC)/FIPSLD_CC='\$(CC)'/g" -e 's/CC=$${CC}/CC="$${CC}"/g' apps/Makefile.orig > apps/Makefile
mv test/Makefile test/Makefile.orig
sed -e "s/FIPSLD_CC=\$(CC)/FIPSLD_CC='\$(CC)'/g" -e 's/CC=$${CC}/CC="$${CC}"/g' test/Makefile.orig > test/Makefile

make -f Makefile all

%install
rm -rf %{buildroot}
%sony_target_dev_setup

make -f Makefile  install INSTALL_PREFIX=%{buildroot}%{sony_target_dir}
install -m 0644 libcrypto.static \
	%{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/libcrypto.a
install -m 0644 libssl.static \
	%{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/libssl.a

mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}/ssl/
mv %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/{certs,openssl.cnf,private} \
	%{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}/ssl/
ln -s ../../../etc/ssl/{certs,openssl.cnf,private} \
	%{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/

cp -af lib*.so* \
	%{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}

# Fix up libs permissions.. just in case...
chmod 0644 %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/lib*

# Create the major version links
(
        cd %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}
        ln -s libcrypto.so.%{shlib_maj}.%{shlib_min} libcrypto.so.%{libmaj}
        ln -s libssl.so.%{shlib_maj}.%{shlib_min} libssl.so.%{libmaj}
#	ln -s libcrypto.so.%{libmaj}.%{libmin}.%{librel} libcrypto.so
#	ln -s libssl.so.%{libmaj}.%{libmin}.%{librel} libssl.so
)

# clean out unpackaged files

rm -rf  %{buildroot}%{sony_target_dir}%{sony_target_dev_data_dir}/man
rm -rf  %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/man
rm -rf  %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/fips_premain.*

# 6.x
    mkdir -p  %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}
    mv %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/*.a \
       %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}

    for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}`
    do
	if [ "$l" != "pkgconfig" -a "$l" != "optinfo" ]; then
	   ln -s ../..%{sony_target_devtool_lib_dir}/$l \
	       %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l
	fi
    done

mkdir -p  %{buildroot}%{sony_target_dir}%{sony_target_dev_include_dir}
mv  %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/usr/include/* \
        %{buildroot}%{sony_target_dir}%{sony_target_dev_include_dir}

%clean
rm -rf $RPM_BUILD_ROOT


%files -n %{pkgname}
%defattr(0644,root,root,0755)
### %doc CHANGES CHANGES.SSLeay LICENSE NEWS README

%attr(0755,root,root)%{sony_target_dir}%{sony_target_dev_bin_dir}/c_rehash
%attr(0755,root,root)%{sony_target_dir}%{sony_target_dev_bin_dir}/openssl

%{sony_target_dir}%{sony_target_dev_lib_dir}/libcrypto.so.%{shlib_maj}.%{shlib_min}
%{sony_target_dir}%{sony_target_dev_lib_dir}/libssl.so.%{shlib_maj}.%{shlib_min}

%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/certs
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/engines/lib4758cca.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/engines/libaep.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/engines/libatalla.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/engines/libchil.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/engines/libcswift.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/engines/libgmp.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/engines/libnuron.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/engines/libsureware.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/engines/libubsec.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/engines/libcapi.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/engines/libpadlock.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/misc/CA.pl
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/misc/CA.sh
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/misc/c_hash
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/misc/c_info
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/misc/c_issuer
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/misc/c_name
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/misc/tsget
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/openssl.cnf
%{sony_target_dir}%{sony_target_dev_lib_dir}/ssl/private

%{sony_target_dir}%{sony_target_dev_sysconf_dir}/ssl/certs
%{sony_target_dir}%{sony_target_dev_sysconf_dir}/ssl/openssl.cnf
%{sony_target_dir}%{sony_target_dev_sysconf_dir}/ssl/private

%{sony_target_dir}%{sony_target_dev_lib_dir}/pkgconfig/libcrypto.pc
%{sony_target_dir}%{sony_target_dev_lib_dir}/pkgconfig/libssl.pc
%{sony_target_dir}%{sony_target_dev_lib_dir}/pkgconfig/openssl.pc

%{sony_target_dir}%{sony_target_dev_lib_dir}/libcrypto.a
%{sony_target_dir}%{sony_target_devtool_lib_dir}/libcrypto.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libcrypto.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/libcrypto.so.1
%{sony_target_dir}%{sony_target_dev_lib_dir}/libssl.a
%{sony_target_dir}%{sony_target_devtool_lib_dir}/libssl.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libssl.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/libssl.so.1
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/aes.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/asn1.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/asn1_mac.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/asn1t.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/bio.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/blowfish.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/bn.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/buffer.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/cast.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/comp.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/conf.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/conf_api.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/crypto.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/des.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/des_old.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/dh.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/dsa.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/dso.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/dtls1.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/e_os2.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/ebcdic.h
# commeted for no-ec option in CONFIG_FLAGS
#%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/ec.h
#%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/ecdh.h
#%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/ecdsa.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/engine.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/err.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/evp.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/hmac.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/krb5_asn.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/kssl.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/lhash.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/md4.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/md5.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/obj_mac.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/objects.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/ocsp.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/opensslconf.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/opensslv.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/ossl_typ.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/pem.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/pem2.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/pkcs12.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/pkcs7.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/cms.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/modes.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/ts.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/whrlpool.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/pqueue.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/rand.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/rc2.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/rc4.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/ripemd.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/rsa.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/safestack.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/sha.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/ssl.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/ssl2.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/ssl23.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/ssl3.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/stack.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/store.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/symhacks.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/tls1.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/txt_db.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/ui.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/ui_compat.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/x509.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/x509_vfy.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/x509v3.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/cmac.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/srp.h
%{sony_target_dir}%{sony_target_dev_include_dir}/openssl/srtp.h

%changelog
* Tue Aug 02 2016 Sony Corporation
- Updated to openssl-1.0.2h

* Wed Jun 01 2016 Sony Corporation
- Added CVE-2016-2105, CVE-2016-2106, CVE-2016-2107,
        CVE-2016-2108,CVE-2016-2109,CVE-2016-2176 

* Wed Mar 16 2016 Sony Corporation
- Merging changes from CE Linux 8.2.5.X.

* Wed Jul 01 2015 Sony Corporation
- Added CVE-2014-8176, CVE-2015-1789, CVE-2015-1790, 
        CVE-2015-1791, CVE-2015-1792, CVE-2015-4000

* Mon Jun 22 2015 Sony Corporation
- Corrected the CVE-2014-3569 patch

* Wed Jun 05 2015 Sony Corporation
- Added   CVE-2015-0286, CVE-2015-0287, CVE-2015-0288, CVE-2015-0289,
          CVE-2015-0292, CVE-2015-0293, CVE-2015-0209 fix patches,
          CVE-2014-3507 refreshed fix patch
          patch updated for CVE-2014-3570,CVE-2014-8275

* Tue Feb 17 2015 Sony Corporation
- Added CVE-2014-3569, CVE-2014-3570, CVE-2014-3571, 
	CVE-2014-3572, CVE-2014-8275 and CVE-2015-0204 fix patches.

* Tue Feb 03 2015 Sony Corporation
- Merging changes from CE Linux 8.2.1.X.

* Fri Jan 20 2012 Sony Corporation 
- update to openssl-0.9.8t 

* Mon Jan 02 2012 Sony Corporation 
- added CVE-2011-3210 security patch 

* Mon Sep 26 2011 Sony Corporation
- added CVE-2011-1945 security patch

* Mon Feb 21 2011 Sony Corporation
- update to openssl-0.9.8r

* Mon Dec 27 2010 Sony Corporation
- added CVE-2010-4180 security patch

* Thu Dec 02 2010 Sony Corporation
- added CVE-2010-3864 security patch

* Mon Nov 22 2010 Sony Corporation
- added no-ec option for CONFIG_FLAGS macro

* Tue Sep 21 2010 Sony Corporation
- added CVE-2010-2939 security patch

* Fri Jun 18 2010 Sony Corporation
- added CVE-2010-0742 security patche

* Thu Jun 03 2010 Sony Corporation
- Replaced multi dialect support with sed
- Removed openssl-0.9.8l-multi-dialect.patch.

* Thu May 13 2010 Sony Corporation
- add CVE-2009-3245, CVE-2010-0433 and CVE-2010-0740 security fix patches

* Tue Mar 09 2010 Sony Corporation
- multi dialect support

* Fri Feb 05 2010 Sony Corporation
- add CVE-2009-4355 security fix patch

* Fri Feb 05 2010 Sony Corporation
- add patches fix regression caused by openssl-0.9.8g-CVE-2009-2409-fix.patch

* Thu Jan 08 2010 Sony Corporation
- update to openssl-0.9.8l to fix CVE-2009-3555

* Tue Dec 22 2009 Sony Corporation
- add CVE-2009-2409 security fix patch

* Fri Nov 20 2009 Sony Corporation
- add CVE-2009-1377, CVE-2009-1378, CVE-2009-1379, CVE-2009-1386 and CVE-2009-1387 security fix patch

* Wed Apr 22 2009 Sony Corporation
- Updated to 6.x 

* Wed Apr 22 2009 Sony Corporation
- update to openssl-0.9.8k

* Mon Jun 16 2008 Sony Corporation
- add .pc file

* Tue Jun 03 2008 Sony Corporation
- add CVE-2008-0891 and CVE-2008-1672 fix patches.

* Wed Oct 31 2007 Sony Corporation
- update to openssl-0.9.8g

* Thu Jul 19 2007 Sony Corporation
- update to openssl-0.9.7m

* Mon Apr 09 2007 Sony Corporation
- security fix CAN-2005-2946

* Mon Oct 16 2006 Sony Corporation
- update to openssl-0.9.7l

* Fri Jun 16 2006 Sony Corporation
- Add -fpic option patch
- Release No 1up (020001->020101)

* Mon Apr 03 2006 Sony Corporation
- update to openssl0.9.7i

* Fri Oct 28 2005 Sony Corporation
- Applied a patch to fix CAN-2005-2969

* Mon Jan 31 2005 Sony Corporation
- update to openssl0.9.7e

* Thu Jan 13 2005 Sony Corporation
- modify for (powerpc & arm)

* Thu Jan 13 2005 Sony Corporation
- delete tmpl pml files

* Tue Dec 21 2004 Sony Corporation
- remove LICENSE

* Tue Nov 16 2004 Sony Corporation
- 2 package -> 1 package

* Thu Nov 11 2004 Sony Corporation
- add Distribution,Vendor,Packager

* Tue Nov 10 2004 Sony Corporation
- change  Name: openssl -> Name: sony-target-dev-openssl

* Fri Nov 05 2004 Sony Corporation - dev-openssl
- Initial build.
